<!--
Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.
-->

# Apache DataFusion Python 47.0.0 Changelog

This release consists of 23 commits from 5 contributors. See credits at the end of this changelog for more information.

**Implemented enhancements:**

- feat: support unparser [#1088](https://github.com/apache/datafusion-python/pull/1088) (chenkovsky)
- feat: update datafusion dependency 47 [#1107](https://github.com/apache/datafusion-python/pull/1107) (timsaucer)
- feat: alias with metadata [#1111](https://github.com/apache/datafusion-python/pull/1111) (chenkovsky)
- feat: add missing PyLogicalPlan to_variant [#1085](https://github.com/apache/datafusion-python/pull/1085) (chenkovsky)
- feat: add user defined table function support [#1113](https://github.com/apache/datafusion-python/pull/1113) (timsaucer)

**Fixed bugs:**

- fix: recursive import [#1117](https://github.com/apache/datafusion-python/pull/1117) (chenkovsky)

**Other:**

- Update changelog and version number [#1089](https://github.com/apache/datafusion-python/pull/1089) (timsaucer)
- Documentation updates: mention correct dataset on basics page [#1081](https://github.com/apache/datafusion-python/pull/1081) (floscha)
- Add Configurable HTML Table Formatter for DataFusion DataFrames in Python [#1100](https://github.com/apache/datafusion-python/pull/1100) (kosiew)
- Add DataFrame usage guide with HTML rendering customization options [#1108](https://github.com/apache/datafusion-python/pull/1108) (kosiew)
- 1075/enhancement/Make col class with __getattr__ [#1076](https://github.com/apache/datafusion-python/pull/1076) (deanm0000)
- 1064/enhancement/add functions to Expr class [#1074](https://github.com/apache/datafusion-python/pull/1074) (deanm0000)
- ci: require approving review [#1122](https://github.com/apache/datafusion-python/pull/1122) (timsaucer)
- Partial fix for 1078: Enhance DataFrame Formatter Configuration with Memory and Display Controls [#1119](https://github.com/apache/datafusion-python/pull/1119) (kosiew)
- Add fill_null method to DataFrame API for handling missing values [#1019](https://github.com/apache/datafusion-python/pull/1019) (kosiew)
- minor: reduce error size [#1126](https://github.com/apache/datafusion-python/pull/1126) (timsaucer)
- Move the udf module to user_defined [#1112](https://github.com/apache/datafusion-python/pull/1112) (timsaucer)
- add unit tests for expression functions [#1121](https://github.com/apache/datafusion-python/pull/1121) (timsaucer)

## Credits

Thank you to everyone who contributed to this release. Here is a breakdown of commits (PRs merged) per contributor.

```
    12	Tim Saucer
     4	Chen Chongchen
     4	kosiew
     2	deanm0000
     1	Florian Schäfer
```

Thank you also to everyone who contributed in other ways such as filing issues, reviewing PRs, and providing feedback on this release.

